--[[
RatRaceTracker v1.0

Original Author: Roman Tarakanov (RTE/Arthas)
Date: Oct 10 '06

Edits By:  Anthony Cuttitta (Darias/Perenolde)
Date April 04, 2007

]]--

local RRT_SV = {};
local RRT_scale = 1;
local TotalCheckpoints = 8;
local RRT_TestingMode = 0;
local cp_coor = {};

function RRT_OnLoad()
-- Initializes addon

  local RaidLoop;
  local FrameXOffset, FrameYOffset;
  local RaidFrameHeight = 20

	SlashCmdList["RATRACETRACKER"] = RRT_slash;
  SLASH_RATRACETRACKER1= "/rrt";
	
	if ( DEFAULT_CHAT_FRAME ) then
    RRT_defaultmsg("RRT 0.9 is loaded,", 1.0, 0.0, 0.0)
		-- DEFAULT_CHAT_FRAME:AddMessage("RRT 0.9 is loaded,", 1.0, 0.0, 0.0);
	end
	
  for RaidLoop=1,40,1 do
		local CurrFrame = getglobal("RRT_raid"..RaidLoop);
	  CurrFrame.name  = getglobal(CurrFrame:GetName().."_name");
    FrameXOffset = 0
		FrameYOffset = math.modf(RaidLoop-1)*(-RaidFrameHeight - 2)
		CurrFrame:SetPoint("TOPLEFT", "RRT_MoveFrame", "BOTTOMRIGHT" , FrameXOffset, FrameYOffset );
	end

	RRT_SV_reset();
	RRT_InitCheckpoints();
	Chronos.scheduleRepeating("RRT_main", 1, RRT_update);
	
end

function RRT_SetScale()
	if (RRT_scale == 1) then RRT_scale = 0.5; else RRT_scale = 1; end
end

function RRT_SV_reset()
	local RaidLoop,CPLoop;
	
	RRT_SV = {}
	
	RRT_SV.timer = {};
	for RaidLoop=1,4,1 do
		RRT_SV.timer[RaidLoop] = 0;
	end

	for RaidLoop=1,40,1 do
      RRT_SV_resetplayer(RaidLoop)
	end
end

function RRT_SV_resetplayer(RaidID)
  local CurrRacerName = UnitName("raid"..RaidID);

  if (CurrRacerName) then
    RRT_defaultmsg("RRT Reseting "..CurrRacerName..", "..RaidID, 1.0, 0.5, 0.5);
    --DEFAULT_CHAT_FRAME:AddMessage("RRT Reseting "..CurrRacerName..", "..RaidID, 1.0, 0.5, 0.5);
    RRT_SV[CurrRacerName] = {};
    RRT_SV[CurrRacerName].cp = {};
    RRT_SV[CurrRacerName].cpp = {};

    for CPLoop=1,TotalCheckpoints,1 do
      RRT_SV[CurrRacerName].cp[CPLoop]  = 0;
      RRT_SV[CurrRacerName].cpp[CPLoop] = 0;
    end

    RRT_SV[CurrRacerName].cheater = 0;
    RRT_SV[CurrRacerName].alive   = 1;
    RRT_SV[CurrRacerName].deaths  = 0;
  end
end

function RRT_set_player(playername)
  RRT_defaultmsg("Setting="..playername, 1.0, 0.0, 0.0);
  --DEFAULT_CHAT_FRAME:AddMessage("Setting="..playername, 1.0, 0.0, 0.0);
	RRT_SV[playername] = {};
	RRT_SV[playername].cp = {};
	RRT_SV[playername].cpp = {};
	
	for CurrRacerName=1,TotalCheckpoints,1 do
		RRT_SV[playername].cp[CurrRacerName]  = 0;
		RRT_SV[playername].cpp[CurrRacerName] = 0;
	end
	
	RRT_SV[playername].cheater = 0;
	RRT_SV[playername].alive   = 1;
	RRT_SV[playername].deaths  = 0;
end

function RRT_slash(msg)

	if (not msg or msg=="") then
		if (RRT_MoveFrame:IsShown()) then
			RRT_MoveFrame:Hide();
		else
			RRT_MoveFrame:Show();
		end
		
	elseif (msg == "reset") then
		RRT_SV_reset();
		RRT_update();

  elseif (type(tonumber(msg)) == "number") then
    RRT_SendCP(tonumber(msg));

	elseif (msg == "resetplayer") then
		RRT_SV_resetplayer();

	end

end

function RRT_initframe(RaidLoop)
	local CurrFrame = getglobal("RRT_raid"..RaidLoop);
	CurrFrame.name  = getglobal(CurrFrame:GetName().."_name");
	CurrFrame.state = getglobal(CurrFrame:GetName().."_state");

	local CheckPointLoop;
	CurrFrame.cp = {};
	CurrFrame.cpp = {};
	
	for CheckPointLoop=1,TotalCheckpoints,1 do
		CurrFrame.cp[CheckPointLoop]  = getglobal(CurrFrame:GetName().."_checkpoint"..CheckPointLoop);
		CurrFrame.cpp[CheckPointLoop] = getglobal(CurrFrame:GetName().."_checkpointpenalty"..CheckPointLoop);
	end
	CurrFrame.total  = getglobal(CurrFrame:GetName().."_totalpenalty");
	CurrFrame.deaths = getglobal(CurrFrame:GetName().."_deaths");
	
	return CurrFrame;
end

function RRT_CurrCoords()
  local Continent,Zone=GetCurrentMapContinent(),GetCurrentMapZone();

  SetMapZoom(0);

  CurrRacerName = UnitName("player");
  local CurrentXCoord,CurrentYCoord=GetPlayerMapPosition("player");
  local MinimapZoneText = GetMinimapZoneText();
  
  local CoordText = "-> -> posX = "..math.floor(CurrentXCoord*1000).."     posY = "..math.floor(CurrentYCoord*1000).."  "..MinimapZoneText;
  RRT_defaultmsg(CoordText, 1.0, 1.0, 1.0);
  --DEFAULT_CHAT_FRAME:AddMessage(CoordText, 1.0, 1.0, 1.0);

  SetMapZoom(Continent,Zone);

end


function RRT_InitCheckpoints()
  -- Insert checkpoints here

  --cp_coor[1] = {posX=719, posY=634, posLocation="General Marcus Jonathan in SW"};     -- TEST START:  In front of Marcus Jonathan in SW
  cp_coor[1] = {posX=770, posY=339, posLocation="The spot in the trees at the base of the cliff"};

  cp_coor[2] = {posX=752, posY=348, posLocation="The middle of bridge over the river in Hillsbrad Foothills"};
  cp_coor[3] = {posX=730, posY=351, posLocation="The middle of the forge in Hillsbrad Fields"};
  cp_coor[4] = {posX=696, posY=315, posLocation="The gate at Sepulcher"};
  cp_coor[5] = {posX=725, posY=262, posLocation="The base of the zepplin tower near Undercity"};
  cp_coor[6] = {posX=749, posY=274, posLocation="The Bulwark / border to Western Plaguelands"};
  cp_coor[7] = {posX=764, posY=300, posLocation="The Ruined House at Chillwind Point"};
  cp_coor[8] = {posX=765, posY=330, posLocation="the end of tunnel at the party"};
  cp_coor[9] = {posX=999, posY=999, posLocation="DISABLED"};
  cp_coor[10] = {posX=999, posY=999, posLocation="DISABLED"};
end

function RRT_LoadRaceRules()
  RaceRules[1] = {ruleText="You will die.  A LOT.  Everyone else will be dying too."};
  RaceRules[2] = {ruleText="You MUST run back to your body after dying.  You may not use a spirit healer to rez."};
  RaceRules[3] = {ruleText="You must run naked.  This eliminates the chances of any possible enchants."};
  RaceRules[4] = {ruleText="You should at least try to have fun.  If you aren't and want to leave...thanks for running as far as you did."};
end

function RRT_SendCP(cp)
  RRT_rwMessage("Checkpoint "..cp..":  "..cp_coor[cp].posLocation)
end

function RRT_SendRaceRules(rulenum)
  RRT_rwMessage("Rule "..rulenum..":  "..RaceRules[rulenum].ruleText)
end

function RRT_incheckpoint(cp, unit)
  -- Check to see if a unit is at a given check point.
  local continent = GetCurrentMapContinent();
	local zoneIndex = GetCurrentMapZone();

  -- Set the map zoom to show both continents
  SetMapZoom(0);
	local posX,posY = GetPlayerMapPosition(unit);
	posX = math.floor(posX*1000);
	posY = math.floor(posY*1000);

	SetMapZoom(continent, zoneIndex);

	if (posX == cp_coor[cp].posX and posY == cp_coor[cp].posY) then
		return 1;
	end

	return nil;

end

function RRT_getpenalty(penalty)
	local PenaltyArray = {};
	local PenaltyTimer;
  local PenaltyMinutes, PenaltySeconds

  -- Get whole number value of penalty (which is in seconds)
	PenaltyFloor = math.floor(penalty);

  if PenaltyFloor<60 then
    -- Less than a full minute
    PenaltyMinutes=0
  else
    -- Minutes is each full multiple of 60 seconds
    PenaltyMinutes = math.modf(PenaltyFloor/60)
  end

  -- Calculate seconds
  PenaltySeconds = PenaltyFloor-(PenaltyMinutes*60)

	if PenaltySeconds<10 then
    -- Show a leading zero for < 10 seconds
    PenaltyTimer = PenaltyMinutes..":0"..PenaltySeconds;
  else
    -- Return the normal seconds value
    PenaltyTimer = PenaltyMinutes..":"..PenaltySeconds;
  end
	
	return PenaltyTimer;
	
end

function RRT_rwMessage(msg)
  if (IsPartyLeader()) then
	   SendChatMessage(msg, "RAID_WARNING");
  end
end

function RRT_defaultmsg(msg, r, g, b)
  DEFAULT_CHAT_FRAME:AddMessage("> > RRT Message:  "..msg, r, g, b);
end

function RRT_update()
	local RaidLoop,CurrCP;

	for RaidLoop=1,GetNumRaidMembers(),1 do
    local CurrFrame = RRT_initframe(RaidLoop);
    local CurrUnit = "raid"..RaidLoop;
    local CurrRacerName, RaidRank, subgroup, level, class, fileName, zone, RacerOnline, dead, role, isML = GetRaidRosterInfo(RaidLoop);

		if (not UnitExists(CurrUnit)) then
			CurrFrame:Hide();
		else
			CurrFrame:Show();
			CurrFrame:SetScale(RRT_scale);

      if (not RRT_SV[CurrRacerName]) then
        RRT_set_player(CurrRacerName);
      end
			
      if UnitIsDeadOrGhost(CurrUnit) then
        -- Death highlight
				CurrFrame.state:SetTexture("Interface\\Addons\\RatRaceTracker\\Icons\\red.tga");
				if (RRT_SV[CurrRacerName].alive == 1) then
					RRT_SV[CurrRacerName].alive = 0;
					RRT_SV[CurrRacerName].deaths = RRT_SV[CurrRacerName].deaths +1;
					RRT_rwMessage(CurrRacerName.." has died. Total deaths: "..RRT_SV[CurrRacerName].deaths);
				end
			elseif (UnitAffectingCombat(CurrUnit)) then
        -- In-combat highlight
				CurrFrame.state:SetTexture("Interface\\Addons\\RatRaceTracker\\Icons\\yellow.tga");
        RRT_SV[CurrRacerName].alive = 1;
			elseif not RacerOnline then
        -- Disconnected highlight
				CurrFrame.state:SetTexture("Interface\\Addons\\RatRaceTracker\\Icons\\blue.tga");
				CurrFrame.name:SetTextColor(0,0,1);
				RRT_SV[CurrRacerName].alive = 0;
			else
        -- Default highlight
				CurrFrame.state:SetTexture("Interface\\AddOns\\RatRaceTracker\\Icons\\green.tga");
				RRT_SV[CurrRacerName].alive = 1;
			end

			CurrFrame.name:SetText(CurrRacerName);


      if IsBuffActive("Resurection Sickness", CurrUnit) then
			  -- Cheater:  Rez sickness = Spirit Res
			  RRT_SV[CurrRacerName].cheater = 1;
			  RRT_rwMessage(CurrRacerName.." has spirit rezzed and will be eliminated from the race!");

        --local resSicknessTime = GetResSicknessDuration();
        --if ( resSicknessTime ) then
        --  DEFAULT_CHAT_FRAME:AddMessage(resSicknessTime, 1.0, 0.25, 0.25);
        --end
      elseif UnitOnTaxi(CurrUnit) then
			  -- Cheater:  No flying around!
			  RRT_SV[CurrRacerName].cheater = 1;
			  RRT_rwMessage(CurrRacerName.." has used a taxi service and will be eliminated from the race!");
      end

			if (RRT_SV[CurrRacerName].cheater == 1) then
				CurrFrame.name:SetTextColor(1,0,0);
			else
				CurrFrame.name:SetTextColor(0,1,0);
			end

			for CurrCP=1,TotalCheckpoints,1 do
        if UnitIsDeadOrGhost(CurrUnit) then
  				-- DEFAULT_CHAT_FRAME:AddMessage(CurrUnit.."is dead jim", 1.0, 0.0, 0.0);
        elseif RaidRank==2 and RRT_TestingMode == 0 then
  				-- DEFAULT_CHAT_FRAME:AddMessage(CurrUnit.."is raid leader", 1.0, 0.0, 0.0);
        elseif RaidRank==1 and RRT_TestingMode == 0 then
  				-- DEFAULT_CHAT_FRAME:AddMessage(CurrUnit.."is an assistant", 1.0, 0.0, 0.0);
        else
  				--DEFAULT_CHAT_FRAME:AddMessage("Checkpoint:"..CurrCP..", UnitID:"..CurrUnit..":"..RRT_incheckpoint(CurrCP, CurrUnit), 1.0, 0.0, 0.0);

  				if (RRT_incheckpoint(CurrCP, CurrUnit) and RRT_SV[CurrRacerName].cp[CurrCP]~=1) then
  					RRT_SV[CurrRacerName].cp[CurrCP] = 1;

  					if (RRT_SV.timer[CurrCP] == 0) then
  						RRT_SV.timer[CurrCP] = 1;
  						Chronos.startTimer("cp"..CurrCP);
  					end

  					--RRT_SV[CurrRacerName].cpp[CurrCP] = Chronos.getTimer("cp"..CurrCP);

  					if (CurrCP<TotalCheckpoints) then
                RRT_rwMessage(CurrRacerName.." - CP "..CurrCP..":  "..cp_coor[CurrCP].posLocation.." has been reached by "..CurrRacerName);
            else
  						  RRT_rwMessage(CurrRacerName.." Finished at "..cp_coor[CurrCP].posLocation.."!");
            end
  				end
        end
			end
			
			for CurrCP=1,TotalCheckpoints,1 do
				if (RRT_SV[CurrRacerName].cp[CurrCP] == 1) then
					CurrFrame.cp[CurrCP]:SetTextColor(0,1,0);
					-- CurrFrame.cpp[CurrCP]:SetText(RRT_getpenalty(RRT_SV[CurrRacerName].cpp[CurrCP]));
				else
					CurrFrame.cp[CurrCP]:SetTextColor(0.3,0.3,0);
				end
			end

      local total_penalty = 0;
			for CurrCP=1,TotalCheckpoints,1 do
				if (RRT_SV[CurrRacerName].cp[CurrCP] == 1) then
					total_penalty = total_penalty + RRT_SV[CurrRacerName].cpp[CurrCP];
				elseif (RRT_SV.timer[CurrCP] == 1) then
					total_penalty = total_penalty + Chronos.getTimer("cp"..CurrCP);
				else
					break;
				end
			end


      CurrFrame.total:SetText(RRT_getpenalty(total_penalty));
      CurrFrame.deaths:SetText("D:"..RRT_SV[CurrRacerName].deaths);
		end
	end
end
